## klibc 2.0.4

=== debian/changelog ===
klibc (2.0.4-9+deb9u1) stretch-security; urgency=high

  * Never clean files in quilt status directory
  * debian/rules: Use $(MAKE) for recursive make
  * debian/rules: Change override_dh_auto_test rule to actually run tests
  * Apply security fixes from 2.0.9 (Closes: #989505):
    - malloc: Set errno on failure
    - malloc: Fail if requested size > PTRDIFF_MAX (CVE-2021-31873)
    - calloc: Fail if multiplication overflows (CVE-2021-31870)
    - cpio: Fix possible integer overflow on 32-bit systems (CVE-2021-31872)
    - cpio: Fix possible crash on 64-bit systems (CVE-2021-31871)

 -- Ben Hutchings <benh@debian.org>  Mon, 28 Jun 2021 16:24:37 +0200

klibc (2.0.4-9) unstable; urgency=medium

  * Change dh_fixperms arguments to restore binary reproducibility
  * initramfs-tools: Ensure busybox's hook runs before ours if it is
    going to be used in the initramfs (Closes: #823323)

 -- Ben Hutchings <ben@decadent.org.uk>  Sun, 08 May 2016 21:59:37 +0100

klibc (2.0.4-8) unstable; urgency=medium

  * run-init: Update documentation comment to cover -n option
  * Add initramfs-tools hook script, in preparation for dropping it from
    the initramfs-tools-core package

 -- Ben Hutchings <ben@decadent.org.uk>  Wed, 10 Feb 2016 23:33:55 +0000

klibc (2.0.4-7) unstable; urgency=medium

  * Drop "revert upstream nuked insmod", as nothing needs it any more
  * Drop "Use static tools on IA64", as this architecture is dead
  * Drop "Use static tools on ppc64", as shared builds appear to work now
  * run-init: Add dry-run mode

 -- Ben Hutchings <ben@decadent.org.uk>  Mon, 18 Jan 2016 17:02:18 +0000

klibc (2.0.4-6) unstable; urgency=medium

  * Revert "syscalls: Use direct socket syscalls on i386" (Closes: #809927)
  * syscalls: Override detection of direct socket syscalls on i386, m68k, s390

 -- Ben Hutchings <ben@decadent.org.uk>  Tue, 05 Jan 2016 21:18:07 +0000

klibc (2.0.4-5) unstable; urgency=medium

  * syscalls: Use direct socket syscalls on i386 (Closes: 809423).
    This requires Linux 4.3.

 -- Ben Hutchings <ben@decadent.org.uk>  Mon, 04 Jan 2016 19:14:50 +0000

klibc (2.0.4-4) unstable; urgency=medium

  * Fix another issue that prevents a reproducible build:
    - Use dh_lintian-overrides instead of direct installation

 -- Ben Hutchings <ben@decadent.org.uk>  Sat, 19 Sep 2015 11:23:44 +0200

klibc (2.0.4-3) unstable; urgency=medium

  * Fix issues that prevent a reproducible build:
    - Install headers with consistent mode
    - dash: mkbuiltins: Fix sort order harder
  * debian/watch: Look for xz-compressed tarballs (Closes: #778299)
    and use HTTP-S
  * Remove udebs as they are no longer used (see #653840)
  * [klibc] Add pread and pwrite 32bit syscall wrappers for parisc
    (Closes: #745660)
  * [klibc] ppc64: fix struct stat (Closes: #783292)
  * debian/control: Add Build-Conflicts: ccache (Closes: #777217)
  * gzip: Fix silent fallback to decompression (Closes: #355809)
  * [klibc] mips/setjmp.S: don't save and restore floating-point registers
    (Closes: #789683)
  * debian/rules: Fix mips* architecture mapping (fixes FTBFS on mips, mipsel)
  * debian/control: Change Vcs-Git, Vcs-Browser and Homepage to canonical
    HTTP-S URLs
  * debian/control: Bump Standards-Version to 3.9.6; no changes required

 -- Ben Hutchings <ben@decadent.org.uk>  Fri, 18 Sep 2015 23:39:49 +0200

klibc (2.0.4-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add mips64 support. (Closes: #741241)

 -- YunQiang Su <syq@debian.org>  Thu, 27 Aug 2015 21:17:00 +0800

klibc (2.0.4-2) unstable; urgency=medium

  * debian/control: Add myself to Uploaders
  * [klibc] MIPS: Update archfcntl.h (fixes FTBFS)
  * Fix compiler warning in usr/klibc/realpath.c

 -- Ben Hutchings <ben@decadent.org.uk>  Sun, 05 Oct 2014 01:13:31 +0100

klibc (2.0.4-1.2) unstable; urgency=medium

  * Non-maintainer upload
  * Implement features needed for mounting /usr in initramfs (Closes: #763049):
    - Implement realpath()
    - readlink: Add -f option
    - mount: Implement -o defaults
  * debian/rules: Fix clean when userland and kernel architecture differ

 -- Ben Hutchings <ben@decadent.org.uk>  Sat, 04 Oct 2014 17:01:24 +0100

klibc (2.0.4-1.1) unstable; urgency=medium

  [ Aurelien Jarno ]
  * Non-maintainer upload.

  [ Mauricio Faria de Oliveira ]
  * Add ppc64el-load-toc-syscall-stub.patch: fix segfault on dynamically-linked
    binaries on ppc64el. (Closes: #749060)

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 17 Sep 2014 13:47:02 +0200

klibc (2.0.4-1) unstable; urgency=medium

  * New upstream release (x86, readlink) (closes: #760587)

 -- maximilian attems <maks@debian.org>  Thu, 11 Sep 2014 21:23:25 +0200

klibc (2.0.3-1) unstable; urgency=medium

  * New upstream release (arm64, ppc64) (closes: #698018, #744884)
    Thanks to Steve Capper <steve.capper@linaro.org>
    and Anton Blanchard <anton@samba.org>.
  * Pump standard version to 3.9.5 without changes.

 -- maximilian attems <maks@debian.org>  Mon, 21 Apr 2014 10:52:22 -0700

=== debian/control ===
Source: klibc
Priority: optional
Maintainer: maximilian attems <maks@debian.org>
Uploaders: Ben Hutchings <ben@decadent.org.uk>
Build-Depends: debhelper (>= 7.0.50), linux-libc-dev, bison, m4
# klcc will depend on ccache if it was installed at build time; see #777217
Build-Conflicts: ccache
Section: libs
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/kernel/klibc.git
Vcs-Git: https://anonscm.debian.org/git/kernel/klibc.git
# maybe some day replace with a real one?
Homepage: https://git.kernel.org/cgit/libs/klibc/klibc.git

Package: libklibc-dev
Section: libdevel
Architecture: any
Depends: libklibc (= ${binary:Version}), linux-libc-dev, ${misc:Depends}
Description: kernel headers used during the build of klibc
 This package contains the set of kernel headers that were required to
 build klibc and the utilities that ship with it.  This may or may
 not be a complete enough set to build other programs that link against
 klibc.  If in doubt, use real kernel headers instead.

Package: libklibc
Architecture: any
Depends: ${misc:Depends}
Description: minimal libc subset for use with initramfs
 klibc is intended to be a minimalistic libc subset for use with
 initramfs.  It is deliberately written for small size, minimal
 entanglement, and portability, not speed.  It is definitely a work in
 progress, and a lot of things are still missing.

Package: klibc-utils
Architecture: any
Depends: libklibc (= ${binary:Version}), ${misc:Depends}
Breaks: initramfs-tools (<< 0.103)
Description: small utilities built with klibc for early boot
 This package contains a collection of programs that are linked
 against klibc. These duplicate some of the functionality of a
 regular Linux toolset, but are typically much smaller than their
 full-function counterparts.  They are intended for inclusion in
 initramfs images and embedded systems.

=== debian/rules ===
#!/usr/bin/make -f

# let debhelper be verbose
#export DH_VERBOSE=1

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH),armel)
DEB_MAKE_ENVVARS := ARCH=arm CONFIG_AEABI=y
endif
ifeq ($(DEB_HOST_ARCH),armhf)
DEB_MAKE_ENVVARS := ARCH=arm CONFIG_AEABI=y CPU_ARCH=armv7-a CPU_TUNE=cortex-a8 CONFIG_KLIBC_THUMB=y
endif
ifeq ($(DEB_HOST_ARCH),ia64)
DEB_MAKE_ENVVARS := ARCH=ia64
endif
ifeq ($(DEB_HOST_ARCH),i386)
DEB_MAKE_ENVVARS := ARCH=i386
endif
ifeq ($(DEB_HOST_ARCH),sparc)
DEB_MAKE_ENVVARS := ARCH=sparc
endif
ifeq ($(DEB_HOST_ARCH),s390)
DEB_MAKE_ENVVARS := ARCH=s390
endif
ifeq ($(DEB_HOST_ARCH),powerpc)
ARCH=ppc
endif
ifneq (,$(filter mips mipsel,$(DEB_HOST_ARCH)))
DEB_MAKE_ENVVARS := ARCH=mips
endif
ifneq (,$(filter mips64 mips64el,$(DEB_HOST_ARCH)))
DEB_MAKE_ENVVARS := ARCH=mips64
endif
ifeq ($(DEB_HOST_ARCH),sh4)
DEB_MAKE_ENVVARS := ARCH=sh
endif
ifeq ($(DEB_HOST_ARCH),ppc64)
DEB_MAKE_ENVVARS := ARCH=ppc64
endif

DEB_MAKE_ENVVARS := INSTALLROOT=debian/tmp $(DEB_MAKE_ENVVARS)

DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
    DEB_MAKE_ENVVARS += CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-
endif


# Enable this to get verbose build information
DEB_MAKE_ENVVARS += KBUILD_VERBOSE=1

%:
	dh $@ --link-doc=libklibc

override_dh_auto_build:
	if [ ! -e linux ]; then \
		rm -rf linux/include; \
		mkdir -p linux/include; \
		ln -s /usr/include/linux linux/include; \
		INC_PATH="/usr/include/asm*"; \
		if [ -n "$(DEB_HOST_MULTIARCH)" ]; then \
			INC_PATH="$${INC_PATH} /usr/include/$(DEB_HOST_MULTIARCH)/asm*"; \
			INC_PATH="$${INC_PATH} /usr/$(DEB_HOST_MULTIARCH)/include/asm*"; \
		fi; \
		for x in $${INC_PATH}; do \
			if [ -e $${x} ] ; then \
				ln -sf $${x} linux/include; \
			fi; \
		done \
	fi
	$(MAKE) all $(DEB_MAKE_ENVVARS)

override_dh_auto_clean:
	rm -rf linux test-*.log
	MAKEFLAGS="$(DEB_MAKE_ENVVARS)" dh_auto_clean

override_dh_auto_install:
	$(MAKE) install $(DEB_MAKE_ENVVARS)

define run_test_program
usr/klibc/tests/$(1) > test-$(1).log
! grep -qw ERROR test-$(1).log
$(if $(2),grep -qF -- $(2) test-$(1).log)
$(if $(3),grep -qF -- $(3) test-$(1).log)
endef

comma=,

override_dh_auto_test:
	$(MAKE) test $(DEB_MAKE_ENVVARS)
	$(call run_test_program,microhello)
	$(call run_test_program,minihello)
	$(call run_test_program,hello)
	$(call run_test_program,environ,'Verifying envp == environ... ok')
#	$(call run_test_program,fcntl)
	$(call run_test_program,malloctest)
	$(call run_test_program,malloctest2)
	$(call run_test_program,opentest,"Line 1 = $$(head -1 /etc/passwd)")
	$(call run_test_program,pipetest)
	$(call run_test_program,select)
	$(call run_test_program,setjmptest,"calling longjmp with 256... setjmp returned 256")
	$(call run_test_program,sigint,"Signal received OK")
	$(call run_test_program,socket)
	$(call run_test_program,sscanf)
	$(call run_test_program,stdio,"Hello$(comma) World!","Hello again - and some more - and some more")
	$(call run_test_program,strlcpycat)
	$(call run_test_program,vfork)
	usr/dash/sh -c "exit"
	usr/dash/sh -c "usr/utils/static/true; exit"

override_dh_fixperms:
	dh_fixperms -X.so

## klibc 2.0.6

=== debian/changelog ===
klibc (2.0.6-1ubuntu1) eoan; urgency=medium

  * Add support to specify ...:dns0:dns1 options to ipconfig -d.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 13 Jun 2019 10:23:04 +0100

klibc (2.0.6-1) unstable; urgency=medium

  * New upstream version:
    - ia64: Fix shared build (thanks to James Clarke)
    - Drop nearly all patches, which are either included or obsoleted
  * debian/control: Change Architecture of all packages to linux-any
  * debian/control: Mark libklibc as M-A: same (suggested by Matthias Klose)
  * debian/control: Mark klibc-utils as M-A: foreign
  * initramfs-tools: Remove checks for shell installed as "sh.shared"
  * debian/rules: Change override_dh_auto_test rule to actually run tests

 -- Ben Hutchings <ben@decadent.org.uk>  Fri, 01 Feb 2019 05:00:57 +0000

klibc (2.0.5-2) unstable; urgency=medium

  * Drop redundant patch "Include the multiarch include directory in klcc's
    path"
  * Drop "Fix klibc Debian specific build trouble" and introduce links in
    debian/rules
  * Fix up debug symbol support:
    - Use -Ttext-segment to link shared library on all arches (Closes: #919855)
    - Drop "kbuild: Enable build IDs"
    - Kbuild: Add option to install unstripped binaries
    - Kbuild: Enable full debug information
    - Set CONFIG_DEBUG_INFO instead of overriding STRIP

 -- Ben Hutchings <ben@decadent.org.uk>  Sun, 20 Jan 2019 22:49:25 +0000

klibc (2.0.5-1) unstable; urgency=medium

  * New upstream version:
    - Drop most of our patches, which are now included upstream

  [ Ben Hutchings ]
  * Simplify commands to set up UAPI headers directory
  * debian/rules: Use $(MAKE) for recursive make
  * Build debug symbols packages
  * libklibc-dev: Remove redundant copy of shared library
  * Fix cross-building for powerpc*, ppc*, s390x

  [ Benjamin Drung ]
  * Fix shellcheck issues in initramfs-tools hook

 -- Ben Hutchings <ben@decadent.org.uk>  Sat, 19 Jan 2019 02:53:52 +0000

klibc (2.0.4-15) unstable; urgency=medium

  * resume: Write resume_offset attribute
  * resume: Backward compatibility for resume_offset
  * x86_64: Use -Ttext-segment to avoid address collision
  * i386: Use -Ttext-segment to avoid address collision
  * Disable PIE, since we link all executables as non-relocatable
    (Closes: #907404)

 -- Ben Hutchings <ben@decadent.org.uk>  Sun, 06 Jan 2019 19:33:01 +0000

klibc (2.0.4-14) unstable; urgency=medium

  [ James Clarke ]
  * [klibc] Fix sparc assembly when compiled as PIC (Closes: #885852)

 -- Ben Hutchings <ben@decadent.org.uk>  Thu, 19 Jul 2018 01:13:54 +0100

klibc (2.0.4-13) unstable; urgency=medium

  * [klibc] rename, renameat: Use renameat2() system call
  * [klibc] Add RISC-V (RV64) port
  * debian/rules: Add architecture mapping for riscv64
  * debian/control: Drop obsolete build-dependency on bison
  * debian/control: Restrict build-dependency on m4 to sparc, sparc64
  * debian/patches: Add Forwarded fields as appropriate
  * debian/rules: Add architecture mapping for sparc64

 -- Ben Hutchings <ben@decadent.org.uk>  Wed, 18 Jul 2018 00:27:22 +0100

klibc (2.0.4-12) unstable; urgency=medium

  [ Ben Hutchings ]
  * debian/control: Point Vcs URLs to Salsa
  * debian/klibc-utils.postinst: Remove diversion of initramfs-tools hook
    script (Closes: #886939)
  * [klibc] mips64: compile with -mno-abicalls, thanks to James Cowgill
    (Closes: #891924)
  * reboot: Add support for reboot syscall argument, thanks to Alfonso
    Sanchez-Beato (Closes: #863761, LP: #1692494)
  * [klibc] x86_64: Reduce ld max-page-size option again (Closes: #903849)
  * Never clean files in quilt status directory

  [ Frank Scheiner ]
  * [klibc] ia64: Build static tools (again)

  [ Benjamin Drung ]
  * ipconfig: Implement classless static routes (Closes: #884716, LP: #1526956)
  * mount_main: Fix empty string check

 -- Ben Hutchings <ben@decadent.org.uk>  Sun, 15 Jul 2018 22:22:07 +0100

klibc (2.0.4-11) unstable; urgency=medium

  * Apply i386 syscall changes from upstream (fixes FTBFS):
    - [klibc] i386: remove special handling of socketcall
    - [klibc] Add accept4(), handle fallback from accept() to accept4()

 -- Ben Hutchings <ben@decadent.org.uk>  Sat, 30 Dec 2017 22:09:36 +0000

klibc (2.0.4-10) unstable; urgency=medium

  [ Steve Langasek ]
  * debian/patches/broadcast_dhcp_send.patch: Set broadcast when sending
    DHCPREQUEST and DHCPDISCOVER.  Thanks to Mathieu Trudel-Lapierre
    <mathieu.trudel-lapierre@canonical.com>.  Closes: #733988, LP:
    #1327412.
  * debian/patches/dhcp-one-socket-per-interface.patch: Use separate
    sockets for DHCP from multiple interfaces.  Thanks to Jay Vosburgh
    <jay.vosburgh@canonical.com>.  Closes: #852480, LP: #1652348.

  [ Ben Hutchings ]
  * Drop patches no longer required after stretch release:
    - "Fix minimal mv to work across fs"
    - "Implement realpath()" and "readlink: Add -f option"
    - "syscalls: Override detection of direct socket syscalls on i386, m68k,
      s390"
  * Replace diversion of initramfs-tools' klibc hook script with versioned
    Breaks
  * debian/control: Bump Standards-Version to 4.1.2; no changes required
  * debian/rules: Use /usr/share/dpkg/architecture.mk
  * Use debhelper compatibility level 9

 -- Ben Hutchings <ben@decadent.org.uk>  Fri, 29 Dec 2017 00:58:39 +0000

=== debian/control ===
Source: klibc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: maximilian attems <maks@debian.org>
Uploaders: Ben Hutchings <ben@decadent.org.uk>
Build-Depends: debhelper (>= 9~), linux-libc-dev, m4 [sparc sparc64]
# klcc will depend on ccache if it was installed at build time; see #777217
Build-Conflicts: ccache
Section: libs
Standards-Version: 4.1.2
Vcs-Browser: https://salsa.debian.org/kernel-team/klibc
Vcs-Git: https://salsa.debian.org/kernel-team/klibc.git
# maybe some day replace with a real one?
Homepage: https://git.kernel.org/cgit/libs/klibc/klibc.git

Package: libklibc-dev
Section: libdevel
Architecture: linux-any
Depends: libklibc (= ${binary:Version}), linux-libc-dev, ${misc:Depends}
Description: kernel headers used during the build of klibc
 This package contains the set of kernel headers that were required to
 build klibc and the utilities that ship with it.  This may or may
 not be a complete enough set to build other programs that link against
 klibc.  If in doubt, use real kernel headers instead.

Package: libklibc
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}
Description: minimal libc subset for use with initramfs
 klibc is intended to be a minimalistic libc subset for use with
 initramfs.  It is deliberately written for small size, minimal
 entanglement, and portability, not speed.  It is definitely a work in
 progress, and a lot of things are still missing.

Package: klibc-utils
Architecture: linux-any
Multi-Arch: foreign
Depends: libklibc (= ${binary:Version}), ${misc:Depends}
Breaks: initramfs-tools (<< 0.123~)
Description: small utilities built with klibc for early boot
 This package contains a collection of programs that are linked
 against klibc. These duplicate some of the functionality of a
 regular Linux toolset, but are typically much smaller than their
 full-function counterparts.  They are intended for inclusion in
 initramfs images and embedded systems.

## klibc 2.0.6.1

=== Makefile ===
SRCROOT = .

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"

# kbuild compatibility
export srctree  := $(or $(KBUILD_SRC),$(shell pwd))
export objtree  := $(shell pwd)
export KLIBCSRC := usr/klibc
export VERSION := $(shell cat $(srctree)/$(KLIBCSRC)/version)
export KLIBCINC := usr/include
export KLIBCOBJ := usr/klibc
export KLIBCKERNELSRC ?= linux

export VPATH := $(srctree)

include $(srctree)/scripts/Kbuild.include

KLIBCROSS	?= $(CROSS_COMPILE)
export KLIBCROSS
export CC	:= $(KLIBCROSS)gcc
export LD	:= $(KLIBCROSS)ld
export AR	:= $(KLIBCROSS)ar
export RANLIB	:= $(KLIBCROSS)ranlib
export STRIP	:= $(KLIBCROSS)strip
export NM	:= $(KLIBCROSS)nm
export OBJCOPY  := $(KLIBCROSS)objcopy
export OBJDUMP  := $(KLIBCROSS)objdump

NOSTDINC_FLAGS := -nostdlib -nostdinc -isystem $(shell $(CC) -print-file-name=include)

ARCH	          := $(shell uname -m | sed -e s/i.86/i386/ \
			-e s/parisc64/parisc/ -e s/sun4u/sparc64/ \
			-e s/arm.*/arm/ -e s/sa110/arm/ \
			-e s/aarch64.*/arm64/ -e s/sh.*/sh/ \
			-e s/ppc64le/ppc64/)
export KLIBCARCH  ?= $(ARCH)
export KLIBCARCHDIR := $(shell echo $(KLIBCARCH) | sed -e s/s390x/s390/)

export HOSTCC     := gcc
export HOSTCFLAGS := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
export PERL       := perl

# Location for installation
export prefix      = /usr
export bindir      = $(prefix)/bin
export libdir      = $(prefix)/lib
export mandir      = $(prefix)/man
export INSTALLDIR  = $(prefix)/lib/klibc
export INSTALLROOT =

# Create a fake .config as present in the kernel tree
# But if it exists leave it alone
$(if $(wildcard $(objtree)/.config),,\
  $(shell cp $(srctree)/defconfig $(objtree)/.config))

# Prefix Make commands with $(Q) to silence them
# Use quiet_cmd_xxx, cmd_xxx to create nice output
# use make V=1 to get verbose output

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# Shorthand to call Kbuild.klibc
klibc := -f $(srctree)/scripts/Kbuild.klibc obj

# Very first target
.PHONY: all klcc klibc
all: klcc klibc

$(objtree)/.config: $(srctree)/defconfig
	@echo "defconfig has changed, please remove or edit .config"
	@false

$(KLIBCKERNELSRC):
	@echo "Cannot find kernel UAPI headers."
	@echo "Either make a 'linux' symlink point to the usr subdirectory "
	@echo "of a kernel tree with headers installed for the $(KLIBCARCH) "
	@echo "architecture or specify KLIBCKERNELSRC=<path>."
	@false

rpmbuild = $(shell which rpmbuild 2>/dev/null || which rpm)

klibc.spec: klibc.spec.in $(KLIBCSRC)/version
	sed -e 's/@@VERSION@@/$(VERSION)/g' < $< > $@

# Build klcc - it is the first target
klcc: $(objtree)/.config $(KLIBCKERNELSRC)
	$(Q)$(MAKE) $(klibc)=klcc

klibc: $(objtree)/.config $(KLIBCKERNELSRC)
	$(Q)$(MAKE) $(klibc)=.

test: klibc
	$(Q)$(MAKE) $(klibc)=usr/klibc/tests

help:
	@echo	'Cleaning targets:'
	@echo	'  clean	- Remove most generated files'
	@echo	'  mrproper	- Remove all generated files + config'
	@echo	'  distclean	- mprproper + editor backup + patch files'
	@echo	''
	@echo	'Build targets:'
	@echo	'all		- Build all targets'
	@echo	'install	- Install klibc'
	@echo	'klcc		- Wrapper around gcc to compile against klibc'
	@echo	'test		- Run klibc tests'
	@echo
	@echo	'Build options:'
	@echo	'KLIBCKERNELSRC - Path to usr directory containing UAPI headers'
	@echo	'make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
	@echo	'make V=2   [targets] 2 => give reason for rebuild of target'
	@echo
	@echo	'Sample invocation:'
	@echo	'make  KLIBCKERNELSRC=`pwd`/../linux/usr/'

###
# allow one to say make dir/file.o
# Caveat: works only for .c files where we have a Kbuild file in same dir
%.o: %.c FORCE
	 $(Q)$(MAKE) $(klibc)=$(dir $<) $(dir $<)$(notdir $@)

%.s: %.c FORCE
	 $(Q)$(MAKE) $(klibc)=$(dir $<) $(dir $<)$(notdir $@)

%.i: %.c FORCE
	 $(Q)$(MAKE) $(klibc)=$(dir $<) $(dir $<)$(notdir $@)

FORCE: ;
###
# clean: remove generated files
# mrproper does a full cleaning including .config and linux symlink
FIND_IGNORE := \( -name .git -o -name .pc \) -prune -o
quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),RM     $(wildcard $(rm-files)))
      cmd_rmfiles = rm -f $(rm-files)
clean:
	$(Q)$(MAKE) -f $(srctree)/scripts/Makefile.clean obj=.
	$(Q)find . $(FIND_IGNORE) \
		\( -name *.o -o -name *.a -o -name '.*.cmd' -o \
		   -name '.*.d' -o -name '.*.tmp' \) \
		-type f -print | xargs rm -f

rm-files := $(objtree)/.config linux
distclean mrproper: clean
	 $(Q)find . $(FIND_IGNORE) \
		\( -name '*.orig' -o -name '*.rej' -o -name '*~' \
		-o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
		-o -name '.*.rej' -o -size 0 \
		-o -name '*%' -o -name '.*.cmd' -o -name 'core' \) \
		-type f -print | xargs rm -f
	$(call cmd,rmfiles)

install: all
	$(Q)$(MAKE) -f $(srctree)/scripts/Kbuild.install obj=.

# This does all the prep work needed to turn a freshly exported git repository
# into a release tarball tree
release: klibc.spec
	rm -f .config

=== debian/changelog ===
klibc (2.0.6.1-3) unstable; urgency=medium

  * update

 -- maximilian attems <maks@debian.org>  Wed, 30 Jun 2021 15:05:04 +0800

klibc (2.0.6-1+deb10u1) buster; urgency=medium

  [ Ben Hutchings ]
  * Apply security fixes from 2.0.9 (Closes: #989505):
    - malloc: Set errno on failure
    - malloc: Fail if requested size > PTRDIFF_MAX (CVE-2021-31873)
    - calloc: Fail if multiplication overflows (CVE-2021-31870)
    - cpio: Fix possible integer overflow on 32-bit systems (CVE-2021-31872)
    - cpio: Fix possible crash on 64-bit systems (CVE-2021-31871)

  [ Thorsten Glaser ]
  * {set,long}jmp [s390x]: save/restore the correct FPU registers
    (f8‥f15 not f1/f3/f5/f7) (Closes: #943425)

 -- Ben Hutchings <benh@debian.org>  Sat, 05 Jun 2021 20:20:42 +0200

## klibc 2.0.7

=== debian/changelog ===
klibc (2.0.7-1ubuntu5.2) focal-security; urgency=medium

  * SECURITY UPDATE: improper pointer arithmetic
    - debian/patches/CVE-2016-9840.patch: remove offset pointer optimization
      in usr/klibc/zlib/inftrees.c.
    - CVE-2016-9840
  * SECURITY UPDATE: improper pointer arithmetic
    - debian/patches/CVE-2016-9841.patch: remove offset pointer optimization
      in usr/klibc/zlib/inffast.c.
    - CVE-2016-9841
  * SECURITY UPDATE: memory corruption during compression
    - debian/patches/CVE-2018-25032.patch: addresses a bug that can crash
      deflate on rare inputs when using Z_FIXED.
    - CVE-2018-25032
  * SECURITY UPDATE: heap-based buffer over-read
    - debian/patches/CVE-2022-37434-1.patch: adds an extra condition to check
      if state->head->extra_max is greater than len before copying, and moves
      the len assignment to be placed before the check in
      usr/klibc/zlib/inflate.c.
    - debian/patches/CVE-2022-37434-2.patch: in the previous patch, the
      placement of the len assignment was causing issues so it was moved
      within the conditional check.
    - CVE-2022-37434

 -- Ian Constantin <ian.constantin@canonical.com>  Sat, 13 Apr 2024 12:35:16 +0300

klibc (2.0.7-1ubuntu5.1) focal-security; urgency=medium

  * SECURITY UPDATE: integer overflow in calloc
    - debian/patches/CVE-2021-31870.patch: add overflow check
      when performing the multiplication in usr/klibc/calloc.c. 
    - CVE-2021-31870
  * SECURITY UPDATE: integer overflow in cpio 
    - debian/patches/CVE-2021-31871.patch: remove cast to unsigned
      to avoid a possible overflow in 64 bit systems in 
      usr/utils/cpio.c.
    - CVE-2021-31871
  * SECURITY UPDATE: integer overflow in read_in_new_ascii
    - debian/patches/CVE-2021-31872.patch: ensure that c_namesize
      and c_filesize are smaller than LONG_MAX in usr/utils/cpio.c.
    - CVE-2021-31872
  * SECURITY UPDATE: integer overflow in malloc
    - debian/patches/CVE-2021-31873.patch: ensure that size is smaller
      than PTRDIFF_MAX in usr/klibc/malloc.c.
    - CVE-2021-31873

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Wed, 13 Apr 2022 10:40:18 +0200

klibc (2.0.7-1ubuntu5) focal; urgency=medium

  * Apply one patch from upstream and one local to resolve type mistmatch
    compiler warnings from the switch to the kernel's UAPI loop.h header.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 06 Nov 2019 23:34:08 -0700

klibc (2.0.7-1ubuntu4) focal; urgency=medium

  * Fix losetup, by switching to kernel uapi header, instead of buggy
    klibc one. LP: #1850184

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 07 Nov 2019 01:08:13 +0000

klibc (2.0.7-1ubuntu3) focal; urgency=medium

  * Make argc_save global.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 31 Oct 2019 18:46:55 +0000

klibc (2.0.7-1ubuntu2) focal; urgency=medium

  * Drop debugging cruft from the previous upload to minimize delta.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 31 Oct 2019 10:35:21 -0600

klibc (2.0.7-1ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    * Fix FTBFS on eoan and later with new gcc
      - cf-protection.patch: Disable cf-protection for syscalls stub.

  * save-argc.patch: when build with gcc-9 linux-5.3, calling ioctl,
    clears global argc, thus save it, to compare to it later. Otheriwse
    losetup -f is broken LP: #1850184

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 31 Oct 2019 11:50:44 +0000

klibc (2.0.7-1) unstable; urgency=medium

  [ Ben Hutchings ]
  * New upstream version:
    - klcc: Enable stripping even if CONFIG_DEBUG_INFO is enabled
    - run-init: Allow the initramfs to be persisted across root changes
      (thanks to Matthew Garrett)
    - ipconfig: Implement support -d ...:dns0:dns1 options (Closes: #931416)
    - Kbuild: Work around broken "ar s" in binutils 2.32 (see #941921)
  * debian/rules: Reorganise make flags variables
  * debian/rules: Define ARCH for klibc, for all architectures
  * debian/rules: Delete redundant architecture mappings
  * debian/rules: Delete redundant export
  * klibc-utils: Trigger update-initramfs on install/upgrade
  * initramfs-tools: Don't install commands that already exist in /sbin
  * initramfs-tools: Exclude kinit and zcat commands earlier
  * initramfs-tools: Exclude gzip command
  * Drop "resume: Backward compatibility for resume_offset", which will
    not be needed in the next release
  * [klibc] fstype: Drop obsolete support for "ext4dev" (Closes: #932926)
  * debian/control: Set Maintainer to Debian Kernel Team; move maks to
    Uploaders

  [ James Clarke ]
  * debian/control: Restrict m4 build dependency to just sparc

  [ Helmut Grohne ]
  * Honour DEB_BUILD_OPTIONS=nocheck. (Closes: #922814)

 -- Ben Hutchings <ben@decadent.org.uk>  Tue, 08 Oct 2019 02:14:11 +0100

klibc (2.0.6-1ubuntu2) eoan; urgency=medium

  * Fix FTBFS on eoan and later with new linux and gcc (LP: #1843743)
    - cf-protection.patch: Disable cf-protection for syscalls stub.
    - mman-include.patch: Adjust for changes to linux headers in 5.3.

 -- Adam Conrad <adconrad@ubuntu.com>  Mon, 21 Oct 2019 15:39:37 -0600

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: klibc
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: maximilian attems <maks@debian.org>
-Uploaders: Ben Hutchings <ben@decadent.org.uk>
-Build-Depends: debhelper (>= 9~), linux-libc-dev, m4 [sparc sparc64]
+XSBC-Original-Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
+Uploaders: Ben Hutchings <ben@decadent.org.uk>, maximilian attems <maks@debian.org>
+Build-Depends: debhelper (>= 9~), linux-libc-dev, m4 [sparc]
 # klcc will depend on ccache if it was installed at build time; see #777217
 Build-Conflicts: ccache
 Section: libs

=== debian/rules ===
#!/usr/bin/make -f

# let debhelper be verbose
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

# klibc architecture names mostly match Debian CPU names.  This is
# overrridden as necessary.
KLIBCARCH := $(patsubst %el,%,$(DEB_HOST_ARCH_CPU))

ifneq (,$(filter amd64 x32,$(DEB_HOST_ARCH)))
KLIBCARCH := x86_64
endif
ifeq ($(DEB_HOST_ARCH),armel)
KLIBC_MAKEFLAGS := CONFIG_AEABI=y
endif
ifeq ($(DEB_HOST_ARCH),armhf)
KLIBC_MAKEFLAGS := CONFIG_AEABI=y CPU_ARCH=armv7-a CPU_TUNE=cortex-a8 CONFIG_KLIBC_THUMB=y
endif
ifeq ($(DEB_HOST_ARCH),hppa)
KLIBCARCH := parisc
endif
ifneq (,$(filter powerpc%,$(DEB_HOST_ARCH)))
KLIBCARCH := ppc
endif
ifeq ($(DEB_HOST_ARCH),sh4)
KLIBCARCH := sh
endif

KLIBC_MAKEFLAGS := INSTALLROOT=debian/tmp ARCH=$(KLIBCARCH) $(KLIBC_MAKEFLAGS)

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
    KLIBC_MAKEFLAGS += CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-
endif


# Enable this to get verbose build information
KLIBC_MAKEFLAGS += KBUILD_VERBOSE=1

# Defer stripping of debug symbols to debhelper
KLIBC_MAKEFLAGS += CONFIG_DEBUG_INFO=y

%:
	dh $@ --link-doc=libklibc

override_dh_auto_build:
	rm -rf linux
	mkdir -p linux/include
	for x in /usr/include/linux /usr/include/asm-generic \
		/usr/include/$(DEB_HOST_MULTIARCH)/asm; do \
		ln -s $${x} linux/include || exit; \
	done
	$(MAKE) all $(KLIBC_MAKEFLAGS)

override_dh_auto_clean:
	rm -rf linux test-*.log
	MAKEFLAGS="$(KLIBC_MAKEFLAGS)" dh_auto_clean

override_dh_auto_install:
	$(MAKE) install $(KLIBC_MAKEFLAGS)
# Replace kernel UAPI header copies with links
	for x in /usr/include/linux /usr/include/asm-generic \
		/usr/include/$(DEB_HOST_MULTIARCH)/asm; do \
		rm -rf debian/tmp/usr/lib/klibc/include/$$(basename $${x}) \
		&& ln -s $${x} debian/tmp/usr/lib/klibc/include/ \
		|| exit; \
	done

define run_test_program
usr/klibc/tests/$(1) > test-$(1).log
! grep -qw ERROR test-$(1).log
$(if $(2),grep -qF -- $(2) test-$(1).log)
$(if $(3),grep -qF -- $(3) test-$(1).log)
endef

comma=,

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	$(MAKE) test $(KLIBC_MAKEFLAGS)
	$(call run_test_program,microhello)
	$(call run_test_program,minihello)
	$(call run_test_program,hello)
	$(call run_test_program,environ,'Verifying envp == environ... ok')
	$(call run_test_program,fcntl)
	$(call run_test_program,malloctest)
	$(call run_test_program,malloctest2)
	$(call run_test_program,opentest,"Line 1 = $$(head -1 /etc/passwd)")
	$(call run_test_program,pipetest)
	$(call run_test_program,select)
	$(call run_test_program,setjmptest,"calling longjmp with 256... setjmp returned 256")
	$(call run_test_program,sigint,"Signal received OK")
	$(call run_test_program,socket)
	$(call run_test_program,sscanf)
	$(call run_test_program,stdio,"Hello$(comma) World!","Hello again - and some more - and some more")
	$(call run_test_program,strlcpycat)
	$(call run_test_program,vfork)
	usr/dash/static/sh -c "exit"
	usr/dash/static/sh -c "usr/utils/static/true; exit"
endif

override_dh_fixperms:
	dh_fixperms -X.so

override dh_strip:
	dh_strip -pklibc-utils -plibklibc

## klibc 2.0.8

=== Makefile ===
--- 
+++ 
@@ -26,6 +26,9 @@
 export NM	:= $(KLIBCROSS)nm
 export OBJCOPY  := $(KLIBCROSS)objcopy
 export OBJDUMP  := $(KLIBCROSS)objdump
+
+LLD := $(shell $(LD) --version 2>&1 | grep LLD)
+export LD_IMAGE_BASE_OPT=$(if $(LLD),--image-base,-Ttext-segment)
 
 NOSTDINC_FLAGS := -nostdlib -nostdinc -isystem $(shell $(CC) -print-file-name=include)
 
@@ -98,11 +101,11 @@
 	@echo "defconfig has changed, please remove or edit .config"
 	@false
 
-$(KLIBCKERNELSRC):
-	@echo "Cannot find kernel UAPI headers."
-	@echo "Either make a 'linux' symlink point to the usr subdirectory "
-	@echo "of a kernel tree with headers installed for the $(KLIBCARCH) "
-	@echo "architecture or specify KLIBCKERNELSRC=<path>."
+$(KLIBCKERNELSRC)/include:
+	@echo 'Missing kernel UAPI headers in $(KLIBCKERNELSRC)/include.'
+	@echo 'Install them by running:'
+	@echo '    make headers_install INSTALL_HDR_PATH=$(abspath $(KLIBCKERNELSRC))'
+	@echo 'in the kernel source directory.'
 	@false
 
 rpmbuild = $(shell which rpmbuild 2>/dev/null || which rpm)
@@ -111,10 +114,10 @@
 	sed -e 's/@@VERSION@@/$(VERSION)/g' < $< > $@
 
 # Build klcc - it is the first target
-klcc: $(objtree)/.config $(KLIBCKERNELSRC)
+klcc: $(objtree)/.config $(KLIBCKERNELSRC)/include
 	$(Q)$(MAKE) $(klibc)=klcc
 
-klibc: $(objtree)/.config $(KLIBCKERNELSRC)
+klibc: $(objtree)/.config $(KLIBCKERNELSRC)/include
 	$(Q)$(MAKE) $(klibc)=.
 
 test: klibc

=== debian/changelog ===
klibc (2.0.8-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  * {set,long}jmp [s390x]: save/restore the correct FPU registers
    (f8‥f15 not f1/f3/f5/f7) (Closes: #943425)

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 27 May 2021 00:12:10 +0200

klibc (2.0.8-6) unstable; urgency=medium

  * Upload to unstable
  * malloc: Set errno on failure
  * malloc: Fail if requested size > PTRDIFF_MAX (CVE-2021-31873)
  * calloc: Fail if multiplication overflows (CVE-2021-31870)
  * cpio: Fix possible integer overflow on 32-bit systems (CVE-2021-31872)
  * cpio: Fix possible crash on 64-bit systems (CVE-2021-31871)

 -- Ben Hutchings <benh@debian.org>  Fri, 30 Apr 2021 03:05:23 +0200

klibc (2.0.8-5) experimental; urgency=medium

  * alpha: Fix definitions of _NSIG and struct sigaction
  * ia64: Fix definition of struct sigaction

 -- Ben Hutchings <benh@debian.org>  Fri, 28 Aug 2020 17:41:47 +0100

klibc (2.0.8-4) experimental; urgency=medium

  * signal: Note another reason to define _KLIBC_NEEDS_SA_RESTORER
  * signal: Add sysconfig setting to force SA_SIGINFO on
  * s390: Force SA_SIGINFO on and use rt_sigreturn
  * alpha: Force SA_SIGINFO on
  * sparc: Force SA_SIGINFO on

 -- Ben Hutchings <benh@debian.org>  Tue, 25 Aug 2020 01:49:14 +0100

klibc (2.0.8-3) experimental; urgency=medium

  * s390: Define __sigreturn() on both s390 and s390x
  * Revert "alpha: Set sa_restorer for signals and disable executable stack"
  * alpha: Pass restorer to rt_sigaction() and disable executable stack

 -- Ben Hutchings <benh@debian.org>  Sun, 23 Aug 2020 15:24:00 +0100

klibc (2.0.8-2) experimental; urgency=medium

  * {alpha,s390,sparc}: Set sa_restorer for signals and disable executable
    stack

 -- Ben Hutchings <benh@debian.org>  Sat, 22 Aug 2020 21:35:52 +0100

klibc (2.0.8-1) unstable; urgency=medium

  [ Ben Hutchings ]
  * New upstream version:
    - ipconfig: Ignore NTP server address and any additional fields
      (Closes: #931416)
    - Kbuild: Add "-fcommon" for clang builds (Closes: #957405)
    - Kbuild: Add a per-architecture option to disable exectable stacks
    - arch: Explicitly disable or enable executable stacks (Closes: #959070)
  * debian/control: Use my debian.org email in Uploaders field
  * Use debhelper compatibility level 12:
    - Build-Depend on debhelper-compat and remove debian/compat
    - debian/klibc-utils.triggers: Delete as redundant
  * debian/rules: Really disable stripping libc.so in libklibc-dev

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Repository.

 -- Ben Hutchings <benh@debian.org>  Fri, 21 Aug 2020 01:34:13 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: klibc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
-Uploaders: Ben Hutchings <ben@decadent.org.uk>, maximilian attems <maks@debian.org>
-Build-Depends: debhelper (>= 9~), linux-libc-dev, m4 [sparc]
+Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
+Uploaders: Ben Hutchings <benh@debian.org>, maximilian attems <maks@debian.org>
+Build-Depends: debhelper-compat (= 12), linux-libc-dev, m4 [sparc]
 # klcc will depend on ccache if it was installed at build time; see #777217
 Build-Conflicts: ccache
 Section: libs
@@ -44,4 +43,3 @@
  regular Linux toolset, but are typically much smaller than their
  full-function counterparts.  They are intended for inclusion in
  initramfs images and embedded systems.
-

=== debian/rules ===
--- 
+++ 
@@ -103,5 +103,6 @@
 override_dh_fixperms:
 	dh_fixperms -X.so
 
-override dh_strip:
+override_dh_strip:
 	dh_strip -pklibc-utils -plibklibc
+	dh_strip -plibklibc-dev -X.so

## klibc 2.0.10

=== debian/changelog ===
klibc (2.0.10-4ubuntu0.1) jammy-security; urgency=medium

  * SECURITY UPDATE: improper pointer arithmetic
    - debian/patches/CVE-2016-9840.patch: remove offset pointer optimization
      in usr/klibc/zlib/inftrees.c.
    - CVE-2016-9840
  * SECURITY UPDATE: improper pointer arithmetic
    - debian/patches/CVE-2016-9841.patch: remove offset pointer optimization
      in usr/klibc/zlib/inffast.c.
    - CVE-2016-9841
  * SECURITY UPDATE: memory corruption during compression
    - debian/patches/CVE-2018-25032.patch: addresses a bug that can crash
      deflate on rare inputs when using Z_FIXED.
    - CVE-2018-25032
  * SECURITY UPDATE: heap-based buffer over-read
    - debian/patches/CVE-2022-37434-1.patch: adds an extra condition to check
      if state->head->extra_max is greater than len before copying, and moves
      the len assignment to be placed before the check in
      usr/klibc/zlib/inflate.c.
    - debian/patches/CVE-2022-37434-2.patch: in the previous patch, the
      placement of the len assignment was causing issues so it was moved
      within the conditional check.
    - CVE-2022-37434

 -- Ian Constantin <ian.constantin@canonical.com>  Sat, 13 Apr 2024 12:34:04 +0300

klibc (2.0.10-4) unstable; urgency=medium

  * d/control, d/rules: Remove ccache from $PATH instead of Build-Conflicting
  * d/salsa-ci.yml: Add CI configuration for salsa.debian.org
  * d/tests: Add klcc smoke test
  * Fix header installation from out-of-tree build (Closes: #1004465)

 -- Ben Hutchings <benh@debian.org>  Mon, 31 Jan 2022 00:28:16 +0100

klibc (2.0.10-3) unstable; urgency=medium

  * ia64: Fix out-of-tree build

 -- Ben Hutchings <benh@debian.org>  Sat, 01 Jan 2022 16:55:44 +0100

klibc (2.0.10-2) unstable; urgency=medium

  * Use KCFLAGS to pass options to Kbuild, rather than CFLAGS and LDFLAGS
    (fixes FTBFS on several architectures)

 -- Ben Hutchings <benh@debian.org>  Fri, 31 Dec 2021 15:05:03 +0100

klibc (2.0.10-1) unstable; urgency=medium

  * New upstream version:
    - Build fixes for Clang (Closes: #787063):
      - Kbuild: Fix include path for Clang builds
      - sparc64: Remove redundant/unsupported compiler option -mptr64
      - s390: mmap: Change inline assembly to work with Clang
  * debian/rules: Pass through $(CC), $(CC_FOR_BUILD), and $(LD) to ease
    building with alternate toolchain
  * debian/rules: Build under debian/build
  * debian/rules: Put test output under debian/build
  * Fix warnings from dh_missing:
    - debian/not-installed: Note duplicate klibc-<hash>.so as not installed
    - debian/libklibc-dev.manpages: Install klcc.1 from debian/tmp
  * debian/*.{install,manpages}: Delete redundant debian/tmp/ prefixes
  * libklibc-dev: Add generated perl dependency for klcc
  * debian/*.lintian-overrides: Delete obsolete overrides
  * debian/libklibc.lintian-overrides: Override
    arch-dependent-file-not-in-arch-specific-directory
  * Kbuild: Use provided CFLAGS, LDFLAGS
  * debian/rules: Use -f{debug,macro}-prefix-map to keep build dir out of
    binaries

 -- Ben Hutchings <benh@debian.org>  Thu, 30 Dec 2021 21:54:47 +0100

klibc (2.0.9-1) unstable; urgency=medium

  * New upstream version
  * armhf: Update compiler options for gcc 11 (Closes: #996906)
  * sig{set,long}jmp: do not ignore sigsetjmp's second argument
    (Closes: #988027)
  * Fix implementation of utimes

 -- Ben Hutchings <benh@debian.org>  Mon, 27 Dec 2021 00:17:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: klibc
 Priority: optional
-Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
 Uploaders: Ben Hutchings <benh@debian.org>, maximilian attems <maks@debian.org>
 Build-Depends: debhelper-compat (= 12), linux-libc-dev, m4 [sparc]
-# klcc will depend on ccache if it was installed at build time; see #777217
-Build-Conflicts: ccache
 Section: libs
 Standards-Version: 4.1.2
 Vcs-Browser: https://salsa.debian.org/kernel-team/klibc
@@ -15,7 +14,8 @@
 Package: libklibc-dev
 Section: libdevel
 Architecture: linux-any
-Depends: libklibc (= ${binary:Version}), linux-libc-dev, ${misc:Depends}
+Depends: libklibc (= ${binary:Version}), linux-libc-dev, ${misc:Depends},
+ ${perl:Depends}
 Description: kernel headers used during the build of klibc
  This package contains the set of kernel headers that were required to
  build klibc and the utilities that ship with it.  This may or may

=== debian/tests/control ===
Tests: klcc
Depends: build-essential, libklibc-dev

## klibc 2.0.12

=== debian/changelog ===
klibc (2.0.12-1) unstable; urgency=medium

  * New upstream version:
    - mips64: Fix struct stat layout (Closes: #1030673)

 -- Ben Hutchings <benh@debian.org>  Sun, 12 Feb 2023 23:57:04 +0100

klibc (2.0.11-1) unstable; urgency=medium

  * New upstream version:
    - Kbuild: Properly disable executable stacks in static builds
      (Closes: #1020883)
    - fcntl: Fix build failure for some architectures with Linux 5.19
      (fixes FTBFS on several architectures)

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + klibc-utils: Drop versioned constraint on initramfs-tools in Breaks.

  [ Ben Hutchings ]
  * lintian: Update override in libklibc for lintian 2.115

 -- Ben Hutchings <benh@debian.org>  Sun, 02 Oct 2022 03:09:49 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: klibc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
+Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
 Uploaders: Ben Hutchings <benh@debian.org>, maximilian attems <maks@debian.org>
 Build-Depends: debhelper-compat (= 12), linux-libc-dev, m4 [sparc]
 Section: libs
@@ -36,7 +35,6 @@
 Architecture: linux-any
 Multi-Arch: foreign
 Depends: libklibc (= ${binary:Version}), ${misc:Depends}
-Breaks: initramfs-tools (<< 0.123~)
 Description: small utilities built with klibc for early boot
  This package contains a collection of programs that are linked
  against klibc. These duplicate some of the functionality of a

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,10 @@
 #export DH_VERBOSE=1
 
 include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/buildtools.mk
+
+empty :=
+space := $(empty) $(empty)
 
 # klibc architecture names mostly match Debian CPU names.  This is
 # overrridden as necessary.
@@ -16,7 +20,7 @@
 KLIBC_MAKEFLAGS := CONFIG_AEABI=y
 endif
 ifeq ($(DEB_HOST_ARCH),armhf)
-KLIBC_MAKEFLAGS := CONFIG_AEABI=y CPU_ARCH=armv7-a CPU_TUNE=cortex-a8 CONFIG_KLIBC_THUMB=y
+KLIBC_MAKEFLAGS := CONFIG_AEABI=y CPU_ARCH=armv7-a+fp CPU_TUNE=cortex-a8 CONFIG_KLIBC_THUMB=y
 endif
 ifeq ($(DEB_HOST_ARCH),hppa)
 KLIBCARCH := parisc
@@ -28,12 +32,16 @@
 KLIBCARCH := sh
 endif
 
-KLIBC_MAKEFLAGS := INSTALLROOT=debian/tmp ARCH=$(KLIBCARCH) $(KLIBC_MAKEFLAGS)
+KLIBC_MAKEFLAGS := -C debian/build -f $(CURDIR)/Makefile KBUILD_SRC=$(CURDIR) INSTALLROOT=../tmp ARCH=$(KLIBCARCH) $(KLIBC_MAKEFLAGS)
 
 ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
     KLIBC_MAKEFLAGS += CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-
 endif
+KLIBC_MAKEFLAGS += CC='$(CC)' HOSTCC='$(CC_FOR_BUILD)' LD='$(LD)'
 
+# Avoid embedding build directory.  We should be able to use just
+# -ffile-prefix-map, but that has no effect on assembly sources!
+KLIBC_MAKEFLAGS += KCFLAGS='-fdebug-prefix-map=$(CURDIR)/= -fmacro-prefix-map=$(CURDIR)/='
 
 # Enable this to get verbose build information
 KLIBC_MAKEFLAGS += KBUILD_VERBOSE=1
@@ -41,21 +49,24 @@
 # Defer stripping of debug symbols to debhelper
 KLIBC_MAKEFLAGS += CONFIG_DEBUG_INFO=y
 
+# klcc will depend on ccache if it is in $PATH at build time; see #777217
+PATH := $(subst $(space),:,$(filter-out %/ccache %/ccache/,$(subst :,$(space),$(PATH))))
+
 %:
 	dh $@ --link-doc=libklibc
 
 override_dh_auto_build:
-	rm -rf linux
-	mkdir -p linux/include
+	rm -rf debian/build/linux
+	mkdir -p debian/build/linux/include
 	for x in /usr/include/linux /usr/include/asm-generic \
 		/usr/include/$(DEB_HOST_MULTIARCH)/asm; do \
-		ln -s $${x} linux/include || exit; \
+		ln -s $${x} debian/build/linux/include || exit; \
 	done
 	$(MAKE) all $(KLIBC_MAKEFLAGS)
+	! grep ccache debian/build/klcc/klcc
 
 override_dh_auto_clean:
-	rm -rf linux test-*.log
-	MAKEFLAGS="$(KLIBC_MAKEFLAGS)" dh_auto_clean
+	rm -rf debian/build
 
 override_dh_auto_install:
 	$(MAKE) install $(KLIBC_MAKEFLAGS)
@@ -68,10 +79,10 @@
 	done
 
 define run_test_program
-usr/klibc/tests/$(1) > test-$(1).log
-! grep -qw ERROR test-$(1).log
-$(if $(2),grep -qF -- $(2) test-$(1).log)
-$(if $(3),grep -qF -- $(3) test-$(1).log)
+cd debian/build && usr/klibc/tests/$(1) > test-$(1).log
+! grep -qw ERROR debian/build/test-$(1).log
+$(if $(2),grep -qF -- $(2) debian/build/test-$(1).log)
+$(if $(3),grep -qF -- $(3) debian/build/test-$(1).log)
 endef
 
 comma=,
@@ -96,8 +107,8 @@
 	$(call run_test_program,stdio,"Hello$(comma) World!","Hello again - and some more - and some more")
 	$(call run_test_program,strlcpycat)
 	$(call run_test_program,vfork)
-	usr/dash/static/sh -c "exit"
-	usr/dash/static/sh -c "usr/utils/static/true; exit"
+	debian/build/usr/dash/static/sh -c "exit"
+	debian/build/usr/dash/static/sh -c "debian/build/usr/utils/static/true; exit"
 endif
 
 override_dh_fixperms:
